%define up_name labltk

# "fix" underlinking:
%define _disable_ld_no_undefined 1

Summary:       Tcl/Tk interface for OCaml
Name:          ocaml-%{up_name}
Version:       8.06.15
Release:       %mkrel 1
Group:         Development/OCaml
License:       LGPLv2+ with exceptions
URL:           https://github.com/garrigue/labltk
Source0:       https://github.com/garrigue/labltk/archive/%{version}/labltk-%{version}.tar.gz
# This adds debugging (-g) everywhere.
Patch1:        labltk-8.06.11-enable-debugging.patch
# Resolve an issue with ./configure and Tcl detection.
Patch2:        labltk-8.06.12-use-fpic-configure.patch
BuildRequires: ocaml
BuildRequires: ocaml-rpm-macros
BuildRequires: pkgconfig(tcl)
BuildRequires: pkgconfig(tk)

%description
labltk or mlTk is a library for interfacing OCaml with the scripting
language Tcl/Tk (all versions since 8.0.3, but no betas).

%package devel
Summary:       Tcl/Tk interface for OCaml
Requires:      %{name}%{?_isa} = %{version}-%{release}

%description devel
labltk or mlTk is a library for interfacing OCaml with the scripting
language Tcl/Tk (all versions since 8.0.3, but no betas).

This package contains the development files.

%prep
%setup -q -n labltk-%{version}
%autopatch -p1

# Remove version control files which might get copied into documentation.
find -name .gitignore -delete

# Kill -warn-error.
find -type f | xargs sed -i -e 's/-warn-error/-w/g'

# Don't build ocamlbrowser.
mv browser browser.old
mkdir browser
echo -e 'all:\ninstall:\n' > browser/Makefile

%build
./configure

# Build does not work in parallel.
unset MAKEFLAGS

%ifarch %{ocaml_native_compiler}
make all opt \
     SHAREDCCCOMPOPTS='%{build_cflags} -fPIC' \
     TK_LINK="%{build_ldflags} $(pkg-config --libs tk)"
%else
make byte
%endif

%install
mkdir -p %buildroot%{_bindir}
mkdir -p %buildroot%{_libdir}/ocaml/labltk
mkdir -p %buildroot%{_libdir}/ocaml/stublibs
make install \
    BINDIR=%buildroot%{_bindir} \
    INSTALLDIR=%buildroot%{_libdir}/ocaml/labltk \
    STUBLIBDIR=%buildroot%{_libdir}/ocaml/stublibs \
    RANLIB=:

sed 's/8\.06\.6/%{version}/' support/META > \
    $RPM_BUILD_ROOT%{ocamldir}/labltk/META

%ocaml_files

%files -f .ofiles
%doc Changes README.mlTk

%files devel -f .ofiles-devel
%doc README.mlTk


%changelog
* Sat May 31 2025 pterjan <pterjan> 8.06.15-1.mga10
+ Revision: 2187617
- Update to 8.06.15

* Wed May 18 2022 pterjan <pterjan> 8.06.11-3.mga9
+ Revision: 1858763
- Rebuild for OCaml 4.14

* Tue Mar 29 2022 umeabot <umeabot> 8.06.11-2.mga9
+ Revision: 1832124
- Mageia 9 Mass Rebuild

* Tue Oct 12 2021 tv <tv> 8.06.11-1.mga9
+ Revision: 1750793
- New upstream version 8.06.11

* Wed Mar 03 2021 tv <tv> 8.06.10-1.mga9
+ Revision: 1696722
- 8.06.10

* Fri Aug 21 2020 umeabot <umeabot> 8.06.5-5.mga8
+ Revision: 1617569
- Rebuild for new ocaml deps generator

* Fri Feb 28 2020 umeabot <umeabot> 8.06.5-4.mga8
+ Revision: 1551145
- Rebuild for ocaml 4.10.0 final

* Wed Feb 19 2020 umeabot <umeabot> 8.06.5-3.mga8
+ Revision: 1544531
- Mageia 8 Mass Rebuild

* Sun Jan 26 2020 tv <tv> 8.06.5-2.mga8
+ Revision: 1483158
- rebuild for ocaml-4.10
- Don't build ocamlbrowser
- disable underlinking

* Tue Oct 23 2018 tv <tv> 8.06.5-2.mga7
+ Revision: 1324070
- rebuild with ocaml-4.07.1

* Mon Oct 22 2018 pterjan <pterjan> 8.06.5-1.mga7
+ Revision: 1323859
- Update to 8.06.5 to support new ocaml
- Rebuild for ocaml 4.07

* Sun Sep 23 2018 umeabot <umeabot> 8.06.4-2.mga7
+ Revision: 1299886
- Mageia 7 Mass Rebuild

* Sun Nov 26 2017 tv <tv> 8.06.4-1.mga7
+ Revision: 1179293
- new release
- use %%version in source URL
- parallel build is broken
- rebuild for new ocaml
- rebuild for new ocaml

* Thu Nov 24 2016 neoclust <neoclust> 8.06.0-3.mga6
+ Revision: 1069810
- Rebuild against fixed ocaml

* Mon Sep 26 2016 pterjan <pterjan> 8.06.0-2.mga6
+ Revision: 1056411
- Rebuild for fix in ocaml

* Fri Jan 29 2016 pterjan <pterjan> 8.06.0-1.mga6
+ Revision: 928672
- Add missing BuildRequires
- Ship META file from findlib
- imported package ocaml-labltk

